meal_plans/urls.py
from django.urls import path


from meal_plans.views import (
    MealPlanListView,
    MealPlanCreateView,
    MealPlanDetailView,
    MealPlanUpdateView,
    MealPlanDeleteView,
)

urlpatterns = [
    path("", MealPlanListView.as_view(), name="mealplans_list"),
    path("create/", MealPlanCreateView.as_view(), name="mealplans_create"),
    path("<int:pk>/", MealPlanDetailView.as_view(), name="mealplans_detail"),
    path("<int:pk>/edit/", MealPlanUpdateView.as_view(), name="mealplans_edit"),
    path(
        "<int:pk>/delete/",
        MealPlanDeleteView.as_view(),
        name="mealplans_delete",
    ),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView

from django.contrib.auth import views as auth_views

urlpatterns = [
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path("meal_plans/", include("meal_plans.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),

]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
    TagDeleteView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
]

meal_plans/models.py
from django.db import models

from django.conf import settings
USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class MealPlan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateField()
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="meal_plans",
        on_delete=models.CASCADE,
        null=True,
    )
    recipes = models.ManyToManyField(
        "recipes.Recipe",
        related_name="recipes",
    )

    def __str__(self):
        return f"{self.name} by {self.owner}"

meal_plans/views.py
from django.shortcuts import redirect

from django.urls import reverse_lazy

from meal_plans.models import MealPlan

from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView

from django.contrib.auth.mixins import LoginRequiredMixin

# Create your views here.


class MealPlanListView(LoginRequiredMixin, ListView):
    model = MealPlan
    template_name = "meal_plans/list.html"
    paginate_by = 3

    # self represents the instance of the class that was created
    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanCreateView(LoginRequiredMixin, CreateView):
    model = MealPlan
    template_name = "meal_plans/create.html"
    fields = ["name", "date", "recipes"]
    success_url = reverse_lazy("mealplans_detail")

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.owner = self.request.user
        plan.save()
        form.save_m2m()
        return redirect("mealplans_detail", pk=plan.id)


class MealPlanDetailView(LoginRequiredMixin, DetailView):
    model = MealPlan
    template_name = "meal_plans/detail.html"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanUpdateView(LoginRequiredMixin, UpdateView):
    model = MealPlan
    template_name = "meal_plans/edit.html"
    fields = ["name", "date", "recipes"]
    
    def get_success_url(self) -> str:
        return reverse_lazy("mealplans_detail", args=[self.object.id])
    
    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanDeleteView(LoginRequiredMixin, DeleteView):
    model = MealPlan
    template_name = "meal_plans/delete.html"
    success_url = reverse_lazy("mealplans_list")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

meal_plans/templates/meal_plans/create.html
{% extends 'base.html' %}

{% block content %}
    <main class="recipe-form">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </main>
{% endblock content %}

meal_plans/templates/meal_plans/delete.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div class="delete-form">
            <form method="post">
                {% csrf_token %}
                <h2>Are you sure you want to delete "{{ mealplan.name }}"?</h2>
                {{ form.as_p }}
                <div>
                    <button class="button">Delete</button>
                </div>
            </form>
        </div>
    </main>
{% endblock content %}

meal_plans/templates/meal_plans/detail.html
{% extends 'base.html' %}


{% block content %}
    <main>
        <div>
            <a href="{% url 'mealplans_edit' mealplan.pk %}">Edit</a>
            <a href="{% url 'mealplans_delete' mealplan.pk %}">Delete</a>
        </div>

        <h2>Recipe{{ mealplan.recipes.all|pluralize }} for {{ mealplan.date | date:"l, F j, Y" }}</h2>
        {% for recipe in mealplan.recipes.all %}
            <p>
                <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
            </p>
        {% endfor %}
    </main>
{% endblock content %}

meal_plans/templates/meal_plans/edit.html
{% extends 'base.html' %}

{% block content %}
    <main class="recipe-form">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Update</button>
            </div>
        </form>
    </main>
{% endblock content %}

meal_plans/templates/meal_plans/list.html
{% extends 'base.html' %}

{% block pagination %}
    <div class="pagination">
        <span class="step-links">
            {% if page_obj.has_previous %}
                <a href="?page=1">&laquo; first</a>
                <a href="?page={{ page_obj.previous_page_number }}">previous</a>
            {% endif %}

            <span class="current">
                Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
            </span>

            {% if page_obj.has_next %} 
                <a href="?page={{ page_obj.next_page_number }}">next</a>
                <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
            {% endif %}
        </span>
    </div>
{% endblock pagination %}

{% block content %}
    <main class="recipe-grid">
        <div class="recipe-card">
            <a href="{% url 'mealplans_create' %}">Create</a>
        </div>
        {% for mealplan in mealplan_list %}
            <div class="recipe-card">
            <h2 class="recipe-card-title">
                    {% comment %} we need the mealplan.pk because in our path
                    in the meal_plans/urls.py file, we reference pk: path("<int:pk>... {% endcomment %}
                <a href="{% url 'mealplans_detail' mealplan.pk %}">{{ mealplan.name }}</a>
            </h2>
            {% for recipe in mealplan.recipes.all %}
                <p>
                    <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
                </p>
        {% endfor %}
            </div>
        {% empty %}
            <div>
                <h2>Your meal plan list is empty.</h2>
                <p>
                    Would you like to
                    <a href="{% url 'mealplans_create' %}">CREATE</a>
                    one?
                </p>
            </div>
        {% endfor %}
    </main>
{% endblock content %}